title   Program to print date
.186
.model  small
.stack  100

.code
;----------------------------- MAIN PROGRAM -------------------------------------
main proc
		mov     ax,@data
        mov     ds,ax           ;set data segment

        mov     ah,9h
        mov     dx,offset msg1
        int     21h             ;print first message

        mov     ah,2ah
        int     21h             ;get current time: in CX,DH,DL

		mov al,dl				;DL = day (1-31)
		call print2				;print day

        mov ah,02h				;function: display out
		mov dl,'/'              ;'/'
        int 21h
		
		mov al,dh				;DH = month (1-12)
		call print2				;print month
		
        mov ah,02h				;function: display out
		mov dl,'/'              ;'/'
        int 21h

		sub cx,2000				;CX = year (1980-2099)
								;get last 2 digits 20xx (being lazy to print 4 digits)
		mov al,cl				;CL = year (0-99)
		call print2				;print year
		
		call printe				;just to leave an empty line (space)
		
        mov     ax,4c00h
        int     21h             ;exit to OS
main endp

;----------------------------- PROCEDURES -------------------------------------
print2 proc near				;print 2 digits (decimal in AL)
		pusha					;save registers
		
		cmp al,99
		ja prn2_e				;exit if more than 2 digits
		;mov bl,al				;store the original number

		;cmp al,10				;if al < 10, skip to
		;jb prn2_2				;next digit

prn2_1:	;print 1st digit
		xor ah,ah				;clear AH (just need AL)
		mov cl,10
		div cl					;AL = AX/CL, AH = remainder
		mov dl,al				;AL has 1st digit
		call printn				;print it

prn2_2:	;print 2nd digit
		mov dl,ah				;AH has 2nd digit
		call printn				;print it

		popa					;restore registers
prn2_e:	ret
print2 endp

printn proc	near				;print a numeral digit in DL
		pusha					;save registers

		add dl,30h              ;adjust number to ASCII
        mov ah,02h              ;function: display out
        int 21h					;char to display
		
		popa					;restore registers
		ret
printn endp		

printe proc	near				;print enter
		pusha					;save registers

        mov ah,02h				;function: display out
		mov dl,0dh              ;carriage return
        int 21h
        mov dl,0ah              ;new line
        int 21h

		popa					;restore registers
		ret
printe endp

		
;----------------------------- DATA -------------------------------------
.data
msg1    db      "Current date: $"

end
